/*      Test file to evaluate debugger file     */
#include <io8096.h>
#include <stdio.h>

/* Generated using ICC8096 V3.10E Compiler:
demo.bat:
icc8096 -rn -e a_demo.c
icc8096 -rn -e a_demo1.c
icc8096 -rn -e cvputchr.c
a8096 a_demo2.s15,a_demo2.lst,,S
a8096 rism_xx.s15,rism_xx.lst,,S
xlink a_demo rism_xx a_demo1 a_demo2 cvputchr -o a_demo.dbg 
	-l a_Demo.map -xs -f lnk8096.xcl -FDEBUG  -Z(CODE)a_demo2
lst2lin -oa_demo2.lin -ma_demo.map  a_demo2.lst

lnk8096.xcl:
-c8096
-Z(CODE)INTVEC=2000
-Z(CODE)CSTART,CODE,RCODE,CDATA,ZVECT,CONST,CSTR,CCSTR=2080
-Z(DATA)DATA,IDATA,UDATA,ECSTR,WCSTR,TEMP,CSTACK=C000
cl8096          


*/

/* test some basic types & static scoping */

static unsigned int a = 1;
const unsigned int us = 65000;
const unsigned char uc = 200;
const signed long sl = -4;
unsigned long timesecs;
unsigned timeticks;
unsigned char byte_value;
/* some arrays */


char str[10] = "0123456789";
int intarray[2][3][4];
float farray[2][3];

/* typedef */
typedef unsigned int UINT;
UINT ui1;

/* typedef & enum */
typedef enum days
{       Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
} DAYS;

/* structs */
struct s1
{       
	struct s1 *next;        /* follow a linked-list (unassigned) */
	char c;
	int s;
	long l;
} struct1 = {&struct1,'a',1,-1L};

struct date
{       DAYS day;
	unsigned char month;
	unsigned long year;
} date[2];

/* union */
union u1
{       char c;
	int s;
	long l;
} union1;

/* bitfields */
struct CBF {
	unsigned cb67:2;
	unsigned cb5:1;
	unsigned cb4:1;
	unsigned cb13:3;
	unsigned cb0:1;
} cbf1, cbf02;  /* char sized */
	
struct BF2 {
	unsigned b:2;   /* mixed bitfield & integer */
	long new;
} bf2;
	
struct BF12 {
	char new;
	unsigned b:2;   /* mixed bitfield & char */
} bf12;
	
struct BF {
	unsigned b1514:2;
	signed b1308:6;
	unsigned b67:2;
	unsigned b5:1;
	unsigned b4:1;
	unsigned b13:3;
	unsigned b0:1;
} bf1, bf02;    /* int sized */
	
union UU {
	unsigned char c;
	struct BF bf;
	char d;
} uu;

struct sUU 
{
	int a;
	union ssUU {
		unsigned char c;
		struct BF bf;
	} ssuu;
	int b;
} suu;

/* setup a linked list for demo purposes */
struct linkedlist
{
	struct linkedlist *next;
	char *text;
};

extern struct linkedlist link1;
struct linkedlist link4 = {&link1, "FOUR"};
struct linkedlist link3 = {&link4, "THREE"};
struct linkedlist link2 = {&link3, "TWO"};
struct linkedlist link1 = {&link2, "ONE"};

void *vp;
void **vpp;

static struct date *    /* static function returns structure pointer */
fdateP(struct date *dateP,struct date *dateP1)
{
	dateP->year++;
	dateP1->year++;
	return dateP;
}

void
wait()
{
	unsigned int temp, i=5000;
	while(i)
	{                      /* waste some time to slow down the LED display */
		temp = i;                
		temp -= 1;
		i = temp;
	}
}

extern int putchar( int c);

void
cycle_byte(unsigned char rotate_byte)
{
	unsigned int i,j;
	unsigned char temp;        
	
	temp = rotate_byte;
	printf("Timer output: %d\n", temp);
	for(j=0; j < 16; j++)
	{        
		temp = rotate(temp);
		wait();
	}
}


unsigned int i;
char buffer[15];

void    
bufputc(char c) 
{
	buffer[i++] = c;        /* note that i above isn't reset by bufputs */
	buffer[i] = '\0';
}

char * 
bufputs(char *s)
{       
	int i;  /* count length in here */
	char *p = s;
	i = 0;
	while (*s) 
	{       
		bufputc(*s++);
		i++;
	}
	return p;
}



char tstr[20];
struct linkedlist *linkP;
struct linkedlist *tlinkP;
struct date *dateP;

main()
{       
	unsigned int i,j;
	unsigned char Tmp;
	char *p;
		/*  To see the Help bar below for function keys: 
			F8 steps over functions
			F7 steps into functions
			F2 toggles breakpoints */
	i = 0;
	i++;
	i <<= 2;
	p = bufputs("Hello, World\n");  /* demo manual example */

	/* prepare timer isr */
	timeticks = timesecs = 0L;
	
	/*      For the Instruction-Set Simulator the TIMER does
		not need to be setup to generate the overflow interrupts. 
		To generate TIMER overflow interrupts set the INT_MASK
		INT_MASK1 registers to enable the TIMER overflow,
		set the I bit in the PSW, and start a periodic
		interrupt from the BKPT menu.                           */
	
	enable_interrupt();
	INT_MASK |= 1;

	linkP = &link1; 
	dateP = &date[1];

	ui1 = 0xffff;
	/* some bitfield manipulations */
	bf1.b67 = 1;
	uu.c = 0x00;
	uu.bf.b13 = 5;
	ui1 = uu.bf.b13;

	for (;;)
	{       
		date[0].day = 1;        /* watch or inspect 'date' while stepping */
		date[1].year = 1989L;   
		date[0].month = '1';
		
		for(i = 0; 
			i < 10;         /* separate lines eases debugging */
				i++)
		{       
			extern struct date fdate_ret(struct date date,struct date date1);
			extern fdate(struct date date,struct date date1);
			extern unsigned fib(int n);
			int a;    /* local a is signed; global is unsigned */
			static b1;
			b1 = 1;
		
	/* some linked list manipulation - inspect the 'next' members */
			tlinkP = linkP->next;
			linkP->next = tlinkP->next;      /* splice second link out */
			linkP = linkP->next;    /* advance for next loop */
			tlinkP->next = linkP->next;
			linkP->next = tlinkP;   /* splice second link after third */

			switch (i)      /* test out switch */
			{
				case 1:
				case 3:
					cycle_byte(byte_value);
					break;
				case 0:
				case 2:
				case 5:                                
				case 7:
				case 8:
				case 9:
					dateP = fdateP(dateP,dateP);    /* test struct pointer */
					a = fdate(date[0],date[1]);     /* test struct args */
					*dateP = fdate_ret(date[0],date[1]);    /* test struct args/return */
					break;
				case 4:
				case 6:
					a = fib(i);
					break;
			}
		}
	}
}


int
fdate(struct date date,struct date date1)
{       /* function has 2 structures as parameters */
	date.year++;
	date1.year++;
	return date.day;   
}

struct date     /* function returns structure */
fdate_ret(struct date date,struct date date1)
{
	date.year++;
	date1.year++;
	return date;   
}

unsigned fib (int n)
{       /* a recursive function to show the stacked instances */
    if (n <= 2) 
	return 1;
    return fib(n-1) + fib(n-2);
}
